// Written by TeTeT
// straight forward waypoints via helipads implementation


TTT_fnc_navigate = {
	params ["_boat", "_goal"];
	private ["_dir", "_relDir", "_inc", "_vel"];
	_dir = _boat getdir _goal;
	while {floor(getDir _boat) != floor(_dir)} do {
		_relDir = _boat getRelDir getPos _goal;
		if (_relDir > 180) then {
			_inc = -0.2;
		} else {
			_inc = 0.2;
		};
		_vel = velocity _boat;
		_boat setDir (getDir _boat + _inc);
		_boat setVelocity _vel;
		sleep 0.01;
	};
	while {_boat distance _goal > 5} do {
		_relDir = _boat getRelDir getPos _goal;
			if (_relDir > 5 and _relDir < 355) then {
			if (_relDir > 180) then {
				_inc = -0.2;
			} else {
				_inc = 0.2;
			};
			_vel = velocity _boat;
			_boat setDir (getDir _boat + _inc);
			_boat setVelocity _vel;
		};
		_speed = 20 * 1000 / 3600;
		_dir = _boat getDir _goal;
		_boat setVelocity [_speed * sin _dir, _speed * cos _dir, 0];
		sleep 0.1;
	};
	systemChat "arrived at waypoint";
};

TTT_fnc_sampan = {
	params ["_pos"];
	private ["_type", "_veh", "_goal"];
	_type = ["uns_sampan_cargo", "uns_sampan_fish1", "uns_sampan_large", "uns_sampan_fish2",
		 "uns_sampan_supply", "uns_sampan_transport", "uns_sampan_village"] call bis_fnc_selectRandom;
	_veh = _type createVehicle getPos _pos;
	createVehicleCrew _veh;
	_goal = [Goal1, Goal31] call bis_fnc_selectRandom;
	_wp = (group (crew _veh select 0)) addWaypoint [_goal, 0];

};


// some sampans for traffic
{
	if (random 1 > 0.5) then {
		[_x] call TTT_fnc_sampan;
	};
} forEach [Goal2, Goal3, Goal4, Goal5, Goal6, Goal7, Goal8, Goal9, Goal10,
	   Goal11, Goal12, Goal13, Goal14, Goal15, Goal16, Goal17, Goal18, Goal19, Goal20,
	   Goal21, Goal22, Goal23, Goal24, Goal25, Goal26, Goal27, Goal28, Goal29, Goal30
	  ];


createVehicleCrew boat;
{
	[boat, _x] call TTT_fnc_navigate;
} forEach [Goal1, Goal2, Goal3, Goal4, Goal5, Goal6, Goal7, Goal8, Goal9, Goal10,
	   Goal11, Goal12, Goal13, Goal14, Goal15, Goal16, Goal17, Goal18, Goal19, Goal20,
	   Goal21, Goal22, Goal23, Goal24, Goal25, Goal26, Goal27, Goal28, Goal29, Goal30,
	   Goal31];

